/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package io.swagger.client.api

import io.swagger.client.model.InlineResponse2003
import io.swagger.client.model.InlineResponse2004
import io.swagger.client.ApiInvoker
import io.swagger.client.ApiException

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date

import scala.collection.mutable.HashMap

class DNSApi(val defBasePath: String = "https://www.1gb.ru/api",
                        defApiInvoker: ApiInvoker = ApiInvoker) {
  var basePath = defBasePath
  var apiInvoker = defApiInvoker

  def addHeader(key: String, value: String) = apiInvoker.defaultHeaders += key -> value 

  /**
   * Создание записи домена
   * 
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param addDnsZone зона, которую необходимо создать 
   * @param addDnsRecord  (optional)
   * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)
   * @param bindOnly  (optional)
   * @return String
   */
  def dnsAddGet (token_: String, addDnsZone: String, addDnsRecord: String, iisSiteForDns: String, bindOnly: Boolean) : Option[String] = {
    // create path and map variables
    val path = "/dns/add".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(addDnsZone) != "null") queryParams += "add_dns_zone" -> addDnsZone.toString
if(String.valueOf(addDnsRecord) != "null") queryParams += "add_dns_record" -> addDnsRecord.toString
if(String.valueOf(iisSiteForDns) != "null") queryParams += "iis_site_for_dns" -> iisSiteForDns.toString
if(String.valueOf(bindOnly) != "null") queryParams += "bind_only" -> bindOnly.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Привязка одного домена к другому
   * 
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID домена из списка /dns/list 
   * @param bindTo домен, к которому необходимо сделать привязку (optional)
   * @return String
   */
  def dnsBindGet (token_: String, key_: Integer, bindTo: String) : Option[String] = {
    // create path and map variables
    val path = "/dns/bind".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
if(String.valueOf(bindTo) != "null") queryParams += "bind_to" -> bindTo.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Получить список доменных имён
   * 
   * @param token_ Ключ доступа, полученный при авторизации 
   * @return List[InlineResponse2003]
   */
  def dnsListGet (token_: String) : Option[List[InlineResponse2003]] = {
    // create path and map variables
    val path = "/dns/list".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "array", classOf[InlineResponse2003]).asInstanceOf[List[InlineResponse2003]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Информация по продлению доменов
   * 
   * @param token_ Ключ доступа, полученный при авторизации 
   * @return List[InlineResponse2004]
   */
  def dnsProlongListGet (token_: String) : Option[List[InlineResponse2004]] = {
    // create path and map variables
    val path = "/dns/prolong/list".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "array", classOf[InlineResponse2004]).asInstanceOf[List[InlineResponse2004]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Редактирование \&quot;сырой\&quot; зоны
   * 
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID домена из /dns/list 
   * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить 
   * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать 
   * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV 
   * @param dnsName Имя записи, либо &#39;@&#39; для корневой 
   * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) 
   * @return String
   */
  def dnsRawGet (token_: String, key_: Integer, sDel: Integer, sAdd: Integer, dnsType: String, dnsName: String, dnsValue: String) : Option[String] = {
    // create path and map variables
    val path = "/dns/raw".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
if(String.valueOf(sDel) != "null") queryParams += "s_del" -> sDel.toString
if(String.valueOf(sAdd) != "null") queryParams += "s_add" -> sAdd.toString
if(String.valueOf(dnsType) != "null") queryParams += "dns_type" -> dnsType.toString
if(String.valueOf(dnsName) != "null") queryParams += "dns_name" -> dnsName.toString
if(String.valueOf(dnsValue) != "null") queryParams += "dns_value" -> dnsValue.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Редактировать DNS-зону
   * 
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID домена из /dns/list 
   * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить 
   * @param updManagedMx Значение &#39;1&#39; подтверждает операцию 
   * @return String
   */
  def dnsRawManagedmxGet (token_: String, key_: Integer, managedMx: Integer, updManagedMx: Integer) : Option[String] = {
    // create path and map variables
    val path = "/dns/raw/managedmx".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
if(String.valueOf(managedMx) != "null") queryParams += "managed_mx" -> managedMx.toString
if(String.valueOf(updManagedMx) != "null") queryParams += "upd_managed_mx" -> updManagedMx.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

}
