/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package io.swagger.client.api

import io.swagger.client.model.InlineResponse20011
import io.swagger.client.model.InlineResponse20012
import io.swagger.client.model.InlineResponse20013
import io.swagger.client.ApiInvoker
import io.swagger.client.ApiException

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date

import scala.collection.mutable.HashMap

class VDSHyperVOpenVZApi(val defBasePath: String = "https://www.1gb.ru/api",
                        defApiInvoker: ApiInvoker = ApiInvoker) {
  var basePath = defBasePath
  var apiInvoker = defApiInvoker

  def addHeader(key: String, value: String) = apiInvoker.defaultHeaders += key -> value 

  /**
   * Изменение параметров VDS
   * Изменение параметров уже существующего VDS
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param _type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)
   * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
   * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30 (optional)
   * @param crHvcpu Количество ядер CPU. По умолчанию 2 (optional)
   * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)
   * @param forceMemo  (optional)
   * @param hv1gbPanelVersion  (optional)
   * @param panelInstall Необходимо ли установить панель 1Gb на VDS (optional)
   * @param crSsd1 Создать всю систему на SSD (optional)
   * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)
   * @return String
   */
  def vdsCreateGet (token_: String, _type: String, crHvmem: Integer, crHvdsk: Integer, crHvcpu: Integer, template: String, forceMemo: String, hv1gbPanelVersion: String, panelInstall: Boolean, crSsd1: Boolean, crHvAllSystem: Boolean) : Option[String] = {
    // create path and map variables
    val path = "/vds/create".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(_type) != "null") queryParams += "type" -> _type.toString
if(String.valueOf(crHvmem) != "null") queryParams += "cr_hvmem" -> crHvmem.toString
if(String.valueOf(crHvdsk) != "null") queryParams += "cr_hvdsk" -> crHvdsk.toString
if(String.valueOf(crHvcpu) != "null") queryParams += "cr_hvcpu" -> crHvcpu.toString
if(String.valueOf(template) != "null") queryParams += "template" -> template.toString
if(String.valueOf(forceMemo) != "null") queryParams += "force_memo" -> forceMemo.toString
if(String.valueOf(hv1gbPanelVersion) != "null") queryParams += "hv_1gb_panel_version" -> hv1gbPanelVersion.toString
if(String.valueOf(panelInstall) != "null") queryParams += "panel_install" -> panelInstall.toString
if(String.valueOf(crSsd1) != "null") queryParams += "cr_ssd1" -> crSsd1.toString
if(String.valueOf(crHvAllSystem) != "null") queryParams += "cr_hv_all_system" -> crHvAllSystem.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Удаление VDS
   * Предоставляет функционал для удаления VDS
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера, полученный из /vds/list 
   * @param forceCritical Если true, VDS будет удален срочно (optional)
   * @return String
   */
  def vdsDeleteGet (token_: String, key_: Integer, forceCritical: Boolean) : Option[String] = {
    // create path and map variables
    val path = "/vds/delete".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
if(String.valueOf(forceCritical) != "null") queryParams += "force_critical" -> forceCritical.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Добавление IP на VDS
   * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера, полученный из /vds/list 
   * @return String
   */
  def vdsIpAddGet (token_: String, key_: Integer) : Option[String] = {
    // create path and map variables
    val path = "/vds/ip/add".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Удаление IP с VDS
   * Этот вызов позволяет отвязать IP адрес от VDS
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера, полученный из /vds/list 
   * @param delIp IP адрес, который необходимо удалить 
   * @return String
   */
  def vdsIpDeleteGet (token_: String, key_: Integer, delIp: String) : Option[String] = {
    // create path and map variables
    val path = "/vds/ip/delete".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
if(String.valueOf(delIp) != "null") queryParams += "del_ip" -> delIp.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Список IP-адресов виртуальных серверов
   * Список IP-адресов виртуальных серверов
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера, полученный из /vds/list (optional)
   * @return List[InlineResponse20011]
   */
  def vdsIpListGet (token_: String, key_: Integer) : Option[List[InlineResponse20011]] = {
    // create path and map variables
    val path = "/vds/ip/list".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "array", classOf[InlineResponse20011]).asInstanceOf[List[InlineResponse20011]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Список виртуальных серверов
   * Позволяет получить список виртуальных серверов
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)
   * @return List[InlineResponse20012]
   */
  def vdsListGet (token_: String, key_: Integer) : Option[List[InlineResponse20012]] = {
    // create path and map variables
    val path = "/vds/list".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "array", classOf[InlineResponse20012]).asInstanceOf[List[InlineResponse20012]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Перезагрузка VDS
   * Предоставляет функционал для перезагрузки VDS
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера, полученный из /vds/list 
   * @return String
   */
  def vdsRebootGet (token_: String, key_: Integer) : Option[String] = {
    // create path and map variables
    val path = "/vds/reboot".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Список шаблонов виртуальных серверов
   * Позволяет получить список шаблонов виртуальных серверов
   * @param token_ Ключ доступа, полученный при авторизации 
   * @return List[InlineResponse20013]
   */
  def vdsTemplatesListGet (token_: String) : Option[List[InlineResponse20013]] = {
    // create path and map variables
    val path = "/vds/templates-list".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "array", classOf[InlineResponse20013]).asInstanceOf[List[InlineResponse20013]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Создание VDS
   * Создание новых VDS с произвольными характеристиками
   * @param token_ Ключ доступа, полученный при авторизации 
   * @param key_ ID виртуального сервера, полученный из /vds/list 
   * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
   * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30 (optional)
   * @param crHvcpu Количество ядер CPU. По умолчанию 2 (optional)
   * @return String
   */
  def vdsUpdateGet (token_: String, key_: Integer, crHvmem: Integer, crHvdsk: Integer, crHvcpu: Integer) : Option[String] = {
    // create path and map variables
    val path = "/vds/update".replaceAll("\\{format\\}","json")
    val contentTypes = List("application/json", "application/json")
    val contentType = contentTypes(0)

    // query params
    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    if(String.valueOf(token_) != "null") queryParams += "_token_" -> token_.toString
if(String.valueOf(key_) != "null") queryParams += "_key_" -> key_.toString
if(String.valueOf(crHvmem) != "null") queryParams += "cr_hvmem" -> crHvmem.toString
if(String.valueOf(crHvdsk) != "null") queryParams += "cr_hvdsk" -> crHvdsk.toString
if(String.valueOf(crHvcpu) != "null") queryParams += "cr_hvcpu" -> crHvcpu.toString
    
    
    var postBody: AnyRef = null

    if(contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart()
      
      postBody = mp
    }
    else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(ApiInvoker.deserialize(s, "", classOf[String]).asInstanceOf[String])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

}
