/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package io.swagger.client.model




case class InlineResponse20014 (
  /*  */
  id: Integer,
/*  */
  status: String,
/*  */
  unmovable: String,
/* Включен (активен), если true. */
  online: String,
/* Удален, если true. Данные могут сохраняться. */
  deleted: String,
/* Удален, если true. Данные могут сохраняться. */
  deletedAuto: String,
/*  */
  deletedDump: String,
/*  */
  userId: String,
/*  */
  ftpId: String,
/*  */
  dnsId: String,
/*  */
  iisId: String,
/*  */
  iisBinding: String,
/*  */
  iisPath: String,
/* Уникальное строковое имя сайта (ID). */
  iisComments: String,
/*  */
  memo: String,
/* Дата создания. */
  dateReg: String,
/* Тип веб-сервера. */
  server: String,
/*  */
  serverBak: String,
/*  */
  serverAux: String,
/* Тип сервера недавно изменялся, если true. */
  serverTransition: String,
/*  */
  serverTransitionDtc: String,
/*  */
  blockTransfer: String,
/*  */
  serverChangedTime: String,
/* Размер веб-сайта - объем (Кб). */
  sizeAmount: String,
/* Размер веб-сайта - кол-во файлов. */
  sizeFileCount: String,
/*  */
  sizeFileCountLimit: String,
/* Размер веб-сайта - дата замера. */
  sizeDate: String,
/*  */
  sizePriorityScan: String,
/*  */
  copyLogs: String,
/*  */
  contentComments: String,
/*  */
  contentCommentsVerbose: String,
/*  */
  metaSaveCount: String,
/*  */
  baseFolder: String,
/*  */
  virtualhostConf: String,
/*  */
  virtualhostServer: String,
/*  */
  virtualhostServerConf: String,
/*  */
  liveDayCount: String,
/*  */
  scanDate: String,
/*  */
  globalTransferCount: String,
/*  */
  netLimitFile: String,
/*  */
  netLimitDenyFromIp: String,
/*  */
  netLimitDenyFromAgent: String,
/*  */
  apachePhpPooled: String,
/*  */
  apachePhpPooledExt: String,
/*  */
  apachePhpPooledExtAuto: String,
/*  */
  apachePhpPool1Only: String,
/*  */
  apachePhpPool5Only: String,
/*  */
  apacheSsi: String,
/*  */
  bypassSecurity: String,
/*  */
  flagGenericExec: String,
/*  */
  flagNoWww: String,
/*  */
  baseFolderSuffix: String,
/*  */
  feedbackSpeed: String,
/*  */
  feedbackSpeedDtc: String,
/*  */
  feedbackSpeedFeedback: String,
/*  */
  unixPathOnWindows: String,
/* Ограничение по IP адресам - FTP доступ. */
  ftpIpfilter: String,
/* Ограничение по IP адресам - SSH доступ. */
  sshIpfilter: String,
/*  */
  l3dAuto: String,
/*  */
  awstatsPrimaryDomain: String,
/*  */
  sharepointMode: String,
/*  */
  sharepointModePending: String,
/*  */
  apacheGenericPoolPort: String,
/*  */
  mongrelEnvironment: String,
/*  */
  flagFree: String,
/*  */
  rtmScanDate: String,
/*  */
  analyzeAnalog: String,
/* Включен режим предоставления детализации процессорной нагрузки. */
  cpuDetailsEnabled: String,
/*  */
  contentModeratedStatus: String,
/*  */
  contentModeratedDate: String,
/*  */
  httpFrontendIp: String,
/*  */
  httpFrontendIpTransition: String,
/* Дата последнего превышения процессорной нагрузки. */
  cpuLimitExceededDate: String,
/* Признак сайта-конструктора. */
  aufsTemplate: String,
/*  */
  optionsAutolimit: String,
/* Версия ASP.NET, если отлична от 2.0. */
  iisCreationCommands: String,
/*  */
  iisCreationCommandsUnix: String,
/*  */
  thumbDate: String,
/*  */
  thumbFailed: String,
/*  */
  backupStatDate: String,
/* Дата пофайловой резервной копии. */
  backupDate: String,
/*  */
  detectedPackages: String,
/*  */
  statSitePower: String,
/*  */
  smtpFrom: String,
/*  */
  superBackupDate: String,
/*  */
  backupDeltaStatDate: String,
/* Дата архивной резервной копии. */
  backupDeltaDate: String,
/* Содержимое архивной резервной копии. */
  backupDeltaDesc: String,
/*  */
  altDocrootServer: String,
/*  */
  altDocrootPath: String,
/*  */
  altDocrootStatus: String,
/*  */
  altDocrootStatusCnt: String,
/*  */
  altDocrootStatusDate: String,
/* Последнее изменение привязок доменов для сайта. */
  bindDtc: String,
/*  */
  backupSpecialMode: String,
/*  */
  sizeCheckProblem: String,
/*  */
  wpbDomain: String,
/* Для сайта включен конструктор Parallels WPB. */
  wpbUuid: String,
/*  */
  wpbStatus: String,
/*  */
  adminProtection: String,
/*  */
  sizeComments: String,
/*  */
  altDocrootSsdReq: String,
/*  */
  mailLimit: String,
/*  */
  mailAccept: String,
/*  */
  mailDrop: String,
/* FTP/SSH/SCP/SFTP логин. */
  ftpName: String,
/* FTP/SSH/SCP/SFTP пароль. */
  ftpPwd: String)
